summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorPatrick McDermott <patrick.mcdermott@libiquity.com>2021-01-16 06:58:35 (EST)
committer Patrick McDermott <patrick.mcdermott@libiquity.com>2021-01-16 08:03:27 (EST)
commit49c6ccd1ade27bbb01cc146d22ea60413933c3dd (patch)
treed4cb05ae3f68c1f11bdc1a9b6141e3651231b131
parentda875ea4111b71a2e52e655eaccfa88f34f0175d (diff)
installer/pc: New installer backend
-rw-r--r--src/installer/local.mk3
-rw-r--r--src/installer/pc.sh106
2 files changed, 108 insertions, 1 deletions
diff --git a/src/installer/local.mk b/src/installer/local.mk
index 9b79ba8..2306edb 100644
--- a/src/installer/local.mk
+++ b/src/installer/local.mk
@@ -1,2 +1,3 @@
prokit_SOURCES += \
- src/installer/chroot.sh
+ src/installer/chroot.sh \
+ src/installer/pc.sh
diff --git a/src/installer/pc.sh b/src/installer/pc.sh
new file mode 100644
index 0000000..157894d
--- /dev/null
+++ b/src/installer/pc.sh
@@ -0,0 +1,106 @@
+# PC installer
+#
+# Copyright (C) 2015-2016, 2021 Patrick McDermott
+#
+# This file is part of the ProteanOS Development Kit.
+#
+# The ProteanOS Development Kit is free software: you can redistribute
+# it and/or modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# The ProteanOS Development Kit is distributed in the hope that it
+# will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with the ProteanOS Development Kit. If not, see
+# <http://www.gnu.org/licenses/>.
+
+_installer_pc_log_print()
+{
+ local prefix="${1}"
+ local log="${2}"
+ shift 2
+ local line=
+
+ IFS="${LF}"
+ for line in ${log}; do
+ error '%s: %s' "${prefix}" "${line}"
+ done
+ unset IFS
+}
+
+_installer_pc_make_partition_and_fs()
+{
+ local dev="${1}"
+ shift 1
+ local log=
+
+ info "$(get_msg 'cmd_installer_pc_dd')"
+ if ! log="$(dd if=/dev/zero of="${dev}" bs=512 count=1 2>&1)"; then
+ error "$(get_msg 'cmd_installer_pc_dd_fail')"
+ _installer_pc_log_print 'dd' "${log}"
+ return 1
+ fi
+
+ info "$(get_msg 'cmd_installer_pc_fdisk')"
+ if ${HAVE_SFDISK}; then
+ if ! log="$(printf ',,83,*\n' | ${SFDISK} -- "${dev}" 2>&1)"
+ then
+ error "$(get_msg 'cmd_installer_pc_fdisk_fail')"
+ _installer_pc_log_print 'sfdisk' "${log}"
+ return 1
+ fi
+ elif ${HAVE_FDISK}; then
+ if ! log="$(printf 'n\np\n1\n\n\nt\n83\na\n1\nw\n' |
+ ${FDISK} -- "${dev}" 2>&1)"; then
+ error "$(get_msg 'cmd_installer_pc_fdisk_fail')"
+ _installer_pc_log_print 'fdisk' "${log}"
+ return 1
+ fi
+ fi
+
+ info "$(get_msg 'cmd_installer_pc_mkfs')"
+ if ! log="$(${MKE2FS} -t ext4 -- "${dev}1" 2>&1)"; then
+ error "$(get_msg 'cmd_installer_pc_mkfs_fail')"
+ _installer_pc_log_print 'mke2fs' "${log}"
+ return 1
+ fi
+
+ return 0
+}
+
+installer_pc_main()
+{
+ local arch="${1}"
+ local plat="${2}"
+ local dev="${3}"
+ local foreign="${4}"
+ shift 4
+
+ if ! check_block "${dev}"; then
+ return 1
+ fi
+
+ if ! _installer_pc_make_partition_and_fs "${dev}"; then
+ return 1
+ fi
+ if ! root="$(block_mount "${dev}1")"; then
+ return 1
+ fi
+
+ if ! install_system "${arch}" "${plat}" "${root}" "${foreign}"; then
+ block_umount "${root}"
+ return 1
+ fi
+ block_umount "${root}"
+ return 0
+}
+
+installer_pc_register()
+{
+ register_installer 'pc'
+}
+__init installer_pc_register